package org.greenstone.gsdl3.util;


import org.xml.sax.InputSource;
import org.xml.sax.EntityResolver;
import java.io.File;

// maybe use class loader to find dtds etc????
public class GSEntityResolver implements EntityResolver {

    protected String gsdl3_home = "";

    public GSEntityResolver(String gsdl3_home) {
	this.gsdl3_home = gsdl3_home;
    }
    
    public InputSource resolveEntity (String public_id, String system_id) {

	if (system_id.endsWith(".dtd") && system_id.indexOf("jakarta")!=-1) {
	    int index = system_id.lastIndexOf(File.separatorChar);
	    if (index != -1) {
		system_id = system_id.substring(index+1);
	    }
	    
	    // a local ref
	    system_id = GSFile.dtdDir(gsdl3_home)+File.separatorChar+system_id;
	    return new InputSource(system_id);
	} else if (system_id.endsWith(".dtd") && system_id.indexOf(File.separatorChar)==-1) {
	    system_id = "file://"+GSFile.dtdDir(gsdl3_home)+File.separatorChar+system_id;
	    return new InputSource(system_id);
		
	} 
	return null; // leave it up to teh thing itself
	    
    }
}
